# scripts to test analysis chain for many fields, cuts, etc.
#
# script used for developing code and testing
#
#  many hard wired parameters

RUNTYPE="$1"
# ANALYSIS METHOD (GEO or FROGS)
[[ "$2" ]] && ANAMETHOD=$2 || ANAMETHOD="GEO"

# evndisp version
VERSION="v500-pre05"
SIMSUB="-NN"
SIMSUB=""
VERSIONSUB="${VERSION}${SIMSUB}"
# run list
LIST="runlist_releaseTesting"
# evndisp run parameter files
ERUN="EVNDISP.reconstruction.runparameter.NN"
ERUN="EVNDISP.reconstruction.runparameter"
# CUTS
if [[ $ANAMETHOD = "FROGS" ]]
then
    CUTS=( "frogs25" "frogs43" )
elif [[ $ANAMETHOD = "BDT" ]]
then
    CUTS=( "BDT-moderate" )
else
    CUTS=( "soft2tel" "moderate2tel" "hard2tel" "moderate3tel" "hard3tel" "hard4tel" )
    CUTS=( "soft2tel" "moderate3tel" "hard3tel" "moderate2tel" )
#    CUTS=( "moderateopen" )
fi

# V4
SIMTYPE="GRISU-SW6"
EPOCH="V4"

# V5
SIMTYPE="GRISU-SW6"
EPOCH="V5"

# V6
SIMTYPE="CARE_Oct1402${SIMSUB}"
SIMTYPE="CARE_May1515${SIMSUB}"
SIMTYPE="CARE_Jun0415${SIMSUB}"
SIMTYPE="CARE_Jun1215${SIMSUB}"
SIMTYPE="CARE_Jun2015${SIMSUB}"
SIMTYPE="CARE_Sep0416${SIMSUB}"
SIMTYPE="CARE_Oct1616${SIMSUB}"
EPOCH="V6"

# PKS1424p240: V4, V5, V6
# Tycho: V6
# Crab: V4, V5, V6
# SS 433: V4, V5

# object
# V6
# for O in Crab Tycho PKS1424p240 Mrk501 Mrk421 HESSJ0632057
# V5
# for O in Crab Tycho PKS1424p240
# V4
# for O in PKS1424p240 Mrk501 Mrk421 HESSJ0632057
# for O in 1ES1959p650
for O in Crab
do
    echo $O
    echo
    RLIST="$VERITAS_USER_DATA_DIR/analysis/Results/${VERSION}/$O/${LIST}${EPOCH}_50deg.dat"
    RLIST="$VERITAS_USER_DATA_DIR/analysis/Results/${VERSION}/$O/${LIST}${EPOCH}.LZE.dat"
    RLIST="$VERITAS_USER_DATA_DIR/analysis/Results/${VERSION}/$O/${LIST}${EPOCH}.dat"
    ODIR="$VERITAS_USER_DATA_DIR/analysis/Results/${VERSION}/$O/${VERSIONSUB}"
    mkdir -p $ODIR
    ########### START EVNDISP
    if [[ $RUNTYPE = "EVNDISP" ]]
    then
       ./ANALYSIS.evndisp.sh $RLIST $ODIR $ERUN 1 1
       continue
    fi
    ########### END EVNDISP
    # reconstruction ID
#    for ID in 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27
#    for ID in 17 18 19 20 21 22 23 24 25 26 27
#    for ID in 0
#    for ID in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22
    for ID in 0 1
    do
        if [[ $ANAMETHOD = "GEO" ]] || [[ $ANAMETHOD = "DISP" ]]
        then
            IDIR="$VERITAS_USER_DATA_DIR/analysis/Results/$VERSION/${O}/${D}/${VERSIONSUB}/RecID${ID}_${SIMTYPE}"
        else
            IDIR="$VERITAS_USER_DATA_DIR/analysis/Results/$VERSION/${O}/${D}/${VERSIONSUB}_Frogs/"
        fi
        ########### START MSCW
        if [[ $RUNTYPE = "MSCW" ]]
        then
            ./ANALYSIS.mscw_energy.sh table-$VERSION-auxv01-${SIMTYPE}-ATM21-${EPOCH}-RECMETHOD${ID} $RLIST $ODIR $ID $IDIR
            continue
        fi
        ########### END MSCW
        ########### START FROGS
        if [[ $RUNTYPE = "FROGS" ]]
        then
           ./ANALYSIS.evndisp_frogs.sh $RLIST  $VERITAS_USER_DATA_DIR/analysis/Results/$VERSION/${O}/${D}/${VERSIONSUB}_Frogs/ $IDIR
        fi

        ############ ANASUM ###############
        ##
        # cut
        NCUTS=${#CUTS[@]}
        for (( m = 0; m < $NCUTS; m++ ))
        do
              C=${CUTS[$m]}
              for BC in RE
              do
                    ODIR="$VERITAS_USER_DATA_DIR/analysis/Results/$VERSION/${O}/${VERSIONSUB}_${EPOCH}_anasum_${ANAMETHOD}/${ANAMETHOD}_ID${ID}_${C}_${BC}"
                    RUNPAR="$VERITAS_USER_DATA_DIR/analysis/Results/$VERSION/${O}/runparameter.dat"
                    
                    echo $IDIR
                    echo $ODIR
                    echo $RUNPAR
                    echo $RLIST

                    rm -f $ODIR.log
                    if [[ $RUNTYPE = "ANASUM" ]]
                    then
                         $EVNDISPSYS/bin/anasum -d $ODIR -i 1 -f $RUNPAR -l $ODIR/$C.anasum.dat -o $ODIR.root > $ODIR.log  
                    elif [[ $RUNTYPE = "ANASUM_SUB" ]]
                    then
                        ./ANALYSIS.anasum_parallel_from_runlist.sh ${RLIST} $ODIR $C ${BC} $RUNPAR $IDIR $SIMTYPE $ANAMETHOD 21 $ID
                    fi
                    echo "DONE $ODIR"
               done
        done
    done
done
