#!/bin/bash

if [[ -z "$GAMMALIB" ]] ; then
  echo "GAMMALIB environmental variable not defined"
  exit 1
fi
if [[ -z "$CTOOLS" ]] ; then
  echo "CTOOLS environmental variable not defined"
  exit 1
fi

VERIPY=""
PYPATHS=$(echo $PYTHONPATH | tr ':' '\n' )
echo "PYPATH: " $PYPATHS
for pa in $PYPATHS ; do
  #echo "path:$pa"
  if [ -e "$pa/veripy.py" ] ; then
    VERIPY=$pa
    break
  fi
done
# exit if we didn't find it
if [ -z "$VERIPY" ] ; then
  echo "couldn't find directory containing veripy.py, searched all dirs in \$PYTHONPATH='$PYTHONPATH' , exiting..."
  exit 1
fi
export VERIPY=$VERIPY

#check for background archive
BACKARCHIVE="$VERITAS_EVNDISP_AUX_DIR/RadialAcceptances/ctools_background_archive.fits"
if [ ! -e $BACKARCHIVE  ] ; then
  echo "couldn't find background archive '$BACKARCHIVE', exiting..."
  exit 1
fi

# init gammalib
source "$GAMMALIB/bin/gammalib-init.sh"
echo "GAMMALIB: " $GAMMALIB


# init ctools
source "$CTOOLS/bin/ctools-init.sh"
echo "CTOOLS: " $CTOOLS
